import * as _mui_material_OverridableComponent from '@mui/material/OverridableComponent';
import * as _mui_material from '@mui/material';

declare const apiRoot = "/api/management";
declare const apiUrl: {
    v1: string;
    v2: string;
};
declare const headerNames: {
    link: string;
    location: string;
    total: string;
};
declare const chartTypes: {
    bar: {
        key: string;
        Icon: _mui_material_OverridableComponent.OverridableComponent<_mui_material.SvgIconTypeMap<{}, "svg">> & {
            muiName: string;
        };
    };
    pie: {
        key: string;
        Icon: _mui_material_OverridableComponent.OverridableComponent<_mui_material.SvgIconTypeMap<{}, "svg">> & {
            muiName: string;
        };
    };
};
declare const emptyChartSelection: {
    software: string;
    group: string;
    chartType: string;
    attribute: string;
};
declare const defaultReportType = "distribution";
declare const defaultReports: {
    group: null;
    attribute: string;
    type: string;
    software: string;
    chartType: string;
}[];
declare const BEGINNING_OF_TIME = "2016-01-01T00:00:00.000Z";
declare const locations: {
    eu: {
        key: string;
        title: string;
        location: string;
    };
    us: {
        key: string;
        title: string;
        location: string;
    };
};
declare const PLANS: {
    os: {
        id: string;
        name: string;
        offer: boolean;
        price: string;
        deviceCount: string;
        offerprice: string;
        price2: string;
        features: string[];
    };
    professional: {
        id: string;
        name: string;
        offer: boolean;
        price: string;
        deviceCount: string;
        offerprice: string;
        price2: string;
        features: string[];
    };
    enterprise: {
        id: string;
        name: string;
        price: string;
        deviceCount: string;
        features: string[];
    };
};
declare const ADDONS: {
    configure: {
        id: string;
        title: string;
        description: string;
        needs: string[];
        os: {
            price: string;
            deviceCount: string;
        };
        professional: {
            price: string;
            deviceCount: string;
        };
        eligible: string[];
    };
    troubleshoot: {
        id: string;
        title: string;
        description: string;
        needs: string[];
        os: {
            price: string;
            deviceCount: string;
        };
        professional: {
            price: string;
            deviceCount: string;
        };
        eligible: string[];
    };
    monitor: {
        id: string;
        title: string;
        description: string;
        needs: string[];
        os: {
            price: string;
            deviceCount: string;
        };
        professional: {
            price: string;
            deviceCount: string;
        };
        eligible: string[];
    };
};
declare const BENEFITS: {
    auditlog: {
        id: string;
        benefit: string;
        requiredPlan: string;
    };
    dashboard: {
        id: string;
        benefit: string;
        requiredPlan: string;
    };
    deltaGeneration: {
        id: string;
        benefit: string;
        requiredPlan: string;
    };
    deviceConfiguration: {
        id: string;
        benefit: string;
        requiredAddon: string;
    };
    deviceMonitor: {
        id: string;
        benefit: string;
        requiredAddon: string;
        requiredPlan: string;
    };
    deviceTroubleshoot: {
        id: string;
        benefit: string;
        requiredAddon: string;
    };
    dynamicGroups: {
        id: string;
        benefit: string;
        requiredPlan: string;
    };
    fullFiltering: {
        id: string;
        benefit: string;
        requiredPlan: string;
    };
    gateway: {
        id: string;
        benefit: string;
        requiredPlans: string;
    };
    pausedDeployments: {
        id: string;
        benefit: string;
        requiredPlan: string;
    };
    phasedDeployments: {
        id: string;
        benefit: string;
        requiredPlan: string;
    };
    rbac: {
        id: string;
        benefit: string;
        requiredPlan: string;
    };
    retryDeployments: {
        id: string;
        benefit: string;
        requiredPlan: string;
    };
    scheduledDeployments: {
        id: string;
        benefit: string;
        requiredPlan: string;
    };
    webhookEvents: {
        id: string;
        benefit: string;
        requiredPlan: string;
    };
    default: {
        id: string;
        benefit: string;
        requiredPlan: string;
    };
};
declare const yes: () => boolean;
declare const canAccess: () => boolean;
declare const DARK_MODE = "dark";
declare const LIGHT_MODE = "light";
declare const APPLICATION_JSON_CONTENT_TYPE = "application/json";
declare const APPLICATION_JWT_CONTENT_TYPE = "application/jwt";

export { ADDONS, APPLICATION_JSON_CONTENT_TYPE, APPLICATION_JWT_CONTENT_TYPE, BEGINNING_OF_TIME, BENEFITS, DARK_MODE, LIGHT_MODE, PLANS, apiRoot, apiUrl, canAccess, chartTypes, defaultReportType, defaultReports, emptyChartSelection, headerNames, locations, yes };
